<?php
/**
 * Created by PhpStorm.
 * User: eugeniofonseca
 * Date: 30/06/14
 * Time: 18:38
 */

namespace Service;

class Employee {

    protected $entityManager;
    protected $employeeFactory;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, \Factory\Employee $employeeFactory) {
        $this->entityManager = $entityManager;
        $this->employeeFactory = $employeeFactory;
    }

    public function createEmployee($name, $status, $description, $businessPartnerObject) {

        $entity = $this->employeeFactory->createEmployee($name, $status, $description, $businessPartnerObject);

        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }

    public function updateEmployee($employee, $name, $status, $description, $businessPartnerObject) {
     
        $employeeModel = '\Zeedhi\DevOps\Model\Projectmanagement\Entities\Employee';
        if(!($employee instanceof $employeeModel)){
            $employee = $this->entityManager->find($employeeModel, $employee);
        }
        $employee = $this->employeeFactory->updateEmployee($employee, $name, $status, $description, $businessPartnerObject);
        $this->entityManager->persist($employee);
        $this->entityManager->flush();
        return $employee;
    }

    public function persistEmployee($employee = null, $name, $status, $description, $businessPartnerObject) {
        if(empty($employee)){
            return $this->createEmployee($name, $status, $description, $businessPartnerObject);
        }
        else{
            return $this->updateEmployee($employee, $name, $status, $description, $businessPartnerObject);
        }
    }


    public function deleteEmployee(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Employee $employee) {
        $this->entityManager->remove($employee);
        $this->entityManager->flush();
    }


}