<?php
namespace Util\Events\Organization;

use Doctrine\Common\EventSubscriber;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\ORM\Events;

class Subscriber implements EventSubscriber {

	protected $environment;

	public function __construct(Environment $environment) {
		$this->environment = $environment;
	}

	public function prePersist(LifecycleEventArgs $args) {
		$entity = $args->getEntity();
		if ($entity instanceof OrganizationAble) {
			$organizationId = $this->environment->getCurrentOrganizationId();
			if ($organizationId) {
				$entity->setOrganization($organizationId);
			}
		}
	}

	/**
	 * Returns an array of events this subscriber wants to listen to.
	 *
	 * @return array
	 */
	public function getSubscribedEvents() {
		return array(
			Events::prePersist,
		);
	}
}